import { ComponentInterface } from '../stencil-public-runtime';
export declare class SuperTabComponent implements ComponentInterface {
    el: HTMLSuperTabElement;
    /**
     * Set this to true to prevent vertical scrolling of this tab. Defaults to `false`.
     *
     * This property will automatically be set to true if there is
     * a direct child element of `ion-content`. To override this
     * behaviour make sure to explicitly set this property to `false`.
     */
    noScroll: boolean;
    loaded: boolean;
    visible: boolean;
    componentDidLoad(): void;
    componentDidUpdate(): void;
    /**
     * Check if we have an ion-content as a child and update the `noScroll` property
     * if it's not set yet.
     */
    private checkIonContent;
    /**
     * Returns the root scrollable element
     */
    getRootScrollableEl(): Promise<HTMLElement | null>;
    render(): any;
}
